/**
*
* @author Najeeb
* @date 8-28-2013
* @desc Ford News Event handler; DOM Management
*
*/
var fordnewsAdapter = {
	// Terms page event handler
	initTermsHandler: function(){
		$('.legal_info').attr('href', 'javascript:;');
		// Removes Cancel button in iOS
		if(device.platform.toLowerCase()=='ios'){
            $('#cancel_btn').remove();
            $('#agree_btn').removeClass('right').addClass('full');
        } else {
            // Cancel button click
            $('#cancel_btn').unbind('click').bind('click', function(e){
                e.stopPropagation();
                fordnewsManager.exitFordNews();
            });
        }
		// Agree button click
		$('#agree_btn').unbind('click').bind('click', function(e){
			e.stopPropagation();
			if(fordnewsConfig.isRegister){
				__localStorage.set('useragreement', true);
				fordnewsConfig.userAgreement = true;			
				// register the device to APNS/GCM and get the device token
				//fordnewsManager.pushRegistration();
				__localStorage.set('firsttimeuser', true);
				fordnewsConfig.initCategoriesList = __localStorage.get(fordnewsConfig.categoryListPage+'_data');
				//console.log("fordnewsConfig.initCategoriesList-->"+JSON.stringify(fordnewsConfig.initCategoriesList));
				// Redirect to categoryListPage, if no Categories subscribed
				if (fordnewsConfig.initCategoriesList != undefined && fordnewsConfig.initCategoriesList != null && fordnewsConfig.initCategoriesList != '' && fordnewsConfig.initCategoriesList.selectedCategoryList == ""){
					setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.categoryListPage);},10);
				}else
					setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.articlesPage);},10);
			}else if(fordnewsConfig.retryCount < 3){
				fordnewsConfig.retryCount++;
				fordnewsManager.showSpinner();
				setTimeout(function(){fordnewsManager.pushRegistration();},10);
			}else{
				fordnewsManager.exceptionHandler(fordnewsConfig.fordnewsErrorTitle, fordnewsConfig.registerErrorMsg);
			}
		});
			
		// Third party link event handling
		$('.legal_info').unbind('click').bind('click', function(e){
			e.stopPropagation();
			e.preventDefault();
			setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.licensePage);},10);
		});
	},	
	// Category List page event handler
	initCategoryListHandler: function(){	
		var len_cat = $('.row-config.cat-item').length;	
		var len_chkd = $('.row-config.cat-item.checked').length;
		// Checks select all checkbox if all items checked while loading
		if(len_chkd==len_cat){
				$('#btn-cat-sel-all').addClass('selectall');
		}
		// Select-all check box tap	
		$('#btn-cat-sel-all').unbind('touchend').bind('touchend',function(e){
			e.stopPropagation();
			$(this).toggleClass('selectall');
			$('.row-config.cat-item').toggleClass('checked', $(this).hasClass('selectall'));
			if((fordnewsConfig.firstVisit == 'true' || fordnewsConfig.firstVisit == true) && fordnewsConfig.initCategoriesList != undefined && fordnewsConfig.initCategoriesList != null && fordnewsConfig.initCategoriesList != '' && fordnewsConfig.initCategoriesList.selectedCategoryList == ""){ 
				fordnewsManager.exceptionHandler(fordnewsConfig.catSubTitle, $(__localStorage.get('popupMsg'+fordnewsConfig.userLanguage+'_data')).text());
				fordnewsConfig.firstVisit = false;
				__localStorage.set('firstvisit', false);
			}			
		});
		// Category item tap
		$('.row-config.cat-item').unbind('click').bind('click',function(e){
			e.stopPropagation();
			
			$(this).toggleClass('checked');
			len_chkd = $('.row-config.cat-item.checked').length;
				
			if($(this).hasClass('checked') && (fordnewsConfig.firstVisit == 'true' || fordnewsConfig.firstVisit == true) && fordnewsConfig.initCategoriesList != undefined && fordnewsConfig.initCategoriesList != null && fordnewsConfig.initCategoriesList != '' && fordnewsConfig.initCategoriesList.selectedCategoryList == ""){
				fordnewsManager.exceptionHandler(fordnewsConfig.catSubTitle, $(__localStorage.get('popupMsg'+fordnewsConfig.userLanguage+'_data')).text());
				fordnewsConfig.firstVisit = false;
				__localStorage.set('firstvisit', false);
			}
			// Checks select all checkbox if all items checked
			if(len_chkd==len_cat){
				$('#btn-cat-sel-all').addClass('selectall');
			}else{
				// Unchecks select all checkbox
				$('#btn-cat-sel-all').removeClass('selectall');
			}
		});
		// Category Submit hander
		$('#btn-subscribe').unbind('click').bind('click', function(e){
			e.stopPropagation();
			// To get a comma-separated list of selected category IDs
			var selCatIds = $(".inner img:not(img[style*='display: none'])").map(function() {
                                return this.id
                            }).get().join();
						  //alert("selCatIds-->"+selCatIds);
			if($(".inner img:not(img[style*='display: none'])").length > 0){
				// Update the value to Application server
				var updateUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.updateSubscriptionUrl;				
				var requestJson = {"userId": fordnewsConfig.userId ,"selCategoryIds": selCatIds};
				fordnewsManager.showSpinner();
				fordnewsManager.updateContext(fordnewsConfig.currentContext, updateUrl, requestJson);
			}			
		});
		
		// Category Refresh handler
		$('#btn-cat-refresh').unbind('touchend').bind('touchend', function(e){
			e.stopPropagation();
			__localStorage.set(fordnewsConfig.categoryListPage+'_data', null);
			setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.categoryListPage);},10);
		});
	},
	// Language Selector page event handler
	initLanguageSelectorHandler: function(){
		// Language selector initial check
		var langJson = __localStorage.get(fordnewsConfig.languageSelectorPage+'_data');
		if(langJson && langJson != undefined && langJson != null && langJson != '' && langJson != 'null' && langJson.pushLangCodes != ""){
			var langArray = langJson.pushLangCodes.split(',');
			for(var i=0; i<langArray.length; i++){
				if(langArray[i].toLowerCase() == 'en'){
				    $('#lang_en').addClass('on');
				    $('#lang_en').prop("checked","true");
				}else if(langArray[i].toLowerCase() == 'de'){
    			    $('#lang_de').addClass('on');
    			    $('#lang_de').prop("checked","true");
    			}
			}
		}else if(fordnewsConfig.userLanguage != null && fordnewsConfig.userLanguage != undefined && fordnewsConfig.userLanguage != ''){
			if(fordnewsConfig.userLanguage.toLowerCase() == 'en'){
			    $('#lang_en').addClass('on');
			    $('#lang_en').prop("checked","true");
			}else if(fordnewsConfig.userLanguage.toLowerCase() == 'de'){
                $('#lang_de').addClass('on');
                $('#lang_de').prop("checked","true");			    
			}
		}
			
		// language toggle button

        $('.lang-item .lang-switch').unbind('click').bind('click',function(e){debugger
                e.stopPropagation();
                if($(this).find('input').prop("checked")){
                    $(this).find('input').removeAttr("checked");
                }else{
                    $(this).find('input').prop("checked","true");
                }
                $(this).find('input').toggleClass('on');
                // Find the of selected languages
                var pushLangs = $('.row-config.lang-item .on').map(function() {
                        return $(this).data('lang');
                    }).get().join();
                // Prevent user from deselecting all the languages
                if(pushLangs.length == 0){                    
                    fordnewsManager.exceptionHandler(fordnewsConfig.subLangTitle, fordnewsConfig.languageWarning);
                    $(this).find('input').prop("checked","true");
                    $(this).find('input').toggleClass('on');
                    return;
                }
                // Update the selected languages to Application server
                var updateUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.updatePushLangUrl;              
                var requestJson = {"userId": fordnewsConfig.userId ,"pushLangCodes": pushLangs};
                fordnewsManager.showSpinner();
                //$(this).toggleClass('on');
                fordnewsManager.updateContext(fordnewsConfig.currentContext, updateUrl, requestJson,$(this));
        });
		// About us button click
		$('#aboutus_btn').unbind('click').bind('click', function(e){
			e.stopPropagation();			
			setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.aboutusPage);},10);
		});
	},
	// Recently subscribed page event handler
	initArticlesHandler: function(){
			var fontSize = parseInt($('.article-title').css("font-size"));
			var len=Math.ceil($('.article-title').width()/fontSize*5);
        	/*if (device.platform.toLowerCase() == 'ios') {
				//len = len*window.devicePixelRatio;
			}*/
			//var len=60; //Math.ceil($('.article-title').width()/4.7)*window.devicePixelRatio;
			// Show empty articles
			var responseJson = __localStorage.get(fordnewsConfig.articlesPage+"_data");			
			if(responseJson && responseJson.subscriptionList.length < 1){
				$('#empty-articles').text(fordnewsConfig.emptyRecentArticles);
				$('#empty-articles').show();
			}		    	
			/*$('.article-title').each(function(){
				var title= $(this).html();				
				if(len < title.length){
					$(this).html($.trim(title).substring(0, len).split(" ").slice(0, -1).join(" ") + " ...");
				}
			});	*/				
			// Articles list item click
			$('.subscriptionList').unbind('click').bind('click', function(e){
				e.stopPropagation();
				fordnewsConfig.currentArticleUrl = $(this).find('.headingURL').text();
				fordnewsConfig.currentArticleSocialFlag =  $(this).find('.socialSharing').text() == "Y"? true : false;
				fordnewsConfig.currentArticleTitle = $(this).find('.headingDesc').text();
				fordnewsManager.loadArticleDetailsPage(
                    fordnewsConfig.currentArticleUrl,
                    fordnewsConfig.currentArticleSocialFlag,
                    fordnewsConfig.currentArticleTitle);
    		});
	},
	// AboutUs page event handler
	initAboutUsHandler: function(){
		// license button click
		$('#license_btn').unbind('click').bind('click', function(e){
			e.stopPropagation();			
			setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.licensePage);},10);
		});
	}	
};