/**
*
 * @author Ansad
* @date 8-28-2013
* @desc Ford News configuration file
*
*/
var fordnewsConfig = {
	// App details
	appVersion: '1.2.1',
	// context name mapping ids
	articlesPage: 'articles',	
	termsPage: 'terms',
	categoryListPage: 'categorylist',
	languageSelectorPage: 'languageselector',
	licensePage: 'license',
	aboutusPage: 'aboutus',
	
	// user specific param
	userLanguage: 'en',
	userId: '2253',
	userEnvironment: 'Android',
	userToken: '',
	firstVisit: true,
	userAgreement: true,

	// common param
	requestTimeout: 30000,
	currentContext: null,
	//gcmSenderId: '365586121386',// '490836502858',// for development
	gcmSenderId: '229928447594',// for production
	pushNotification: null,	
	previousContext: null,
	webviewRef: null,
	startPage: null,
	exitFordNews: false,
	isRegister: false,
	initCategoriesList: null,
	disableCacheParam: null,
	retryCount: 0,
	currentArticleUrl: 'http://www.at.ford.com/mobile/Pages/default.aspx',
	currentArticleSocialFlag: 'Y',
	currentArticleTitle: 'Default',
	
	// External connection urls
	//webserviceUrl: 'https://wwwqa.atfordreg.ford.com',// For development
	webserviceUrl: 'https://www.atfordreg.ford.com',  // For production
	//rssfeedUrl: 'http://qam.at.ford.com/_layouts/listfeed.aspx?List=9cfbeebc%2D82f0%2D4cfe%2Dad5b%2Db41826c51c7a&View=95a67e09%2D3277%2D448f%2Db3fe%2D6f02d218ee3b',// For development
	rssfeedUrl: 'http://m.at.ford.com/_layouts/listfeed.aspx?List=9cfbeebc%2D82f0%2D4cfe%2Dad5b%2Db41826c51c7a&View=95a67e09%2D3277%2D448f%2Db3fe%2D6f02d218ee3b',// For production
	
	// Application Server API urls
	userRegisterUrl: '/ATFORDREGUiWeb/jaxrs/Register/registerDevice',
	getCategoryUrl : '/ATFORDREGUiWeb/jaxrs/CategoryService/getCategoryGroup',
	//getCategoryUrl: '/ATFORDREGUiWeb/jaxrs/CategoryService/getCategory',
	updateSubscriptionUrl: '/ATFORDREGUiWeb/jaxrs/CategoryService/updateCategory',
	updatePushLangUrl: '/ATFORDREGUiWeb/jaxrs/Register/updatePushLang',
	getRecentArticlesUrl: '/ATFORDREGUiWeb/jaxrs/SubscriptionService/getRecentSub',
	getUserDetails: '/ATFORDREGUiWeb/jaxrs/Register/getUserDetails',
	updateUserDetails: '/ATFORDREGUiWeb/jaxrs/Register/updateUserDetails',
	getPushLanguages: '/ATFORDREGUiWeb/jaxrs/Register/getPushLanguage',
	
	// URL Building Values
	//hostName: 'http://qam.at.ford.com',// For development
	hostName: 'http://at.ford.com',  // For production
	urlRegionalPart: '/mobile/Pages/article.aspx?article=',
	urlPlantPart: '/mobile/Pages/article.aspx?PlantName=',
	urlGermanPart: '/mobile/Deutsch/Seiten/article.aspx?article=',
	urlPlantSecondPart: '&article=',
	urlLastPart:'.aspx&MobileApp=',
	rssType: {
	    Regional: "RE",
	    Plant: "PL",
	    German: "DE"
	},
	
	//For Converting Date
	monthList: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
	
	// Error Messages
	okButtonText: 'OK',
	cancelButtonText: 'Ignore',
	continueButtonText: 'Read',	
	serverPblmTitle: 'Server Problem',
	serverPblmMsg: 'Server communication failed. Please try again.',	
	serverTimeoutMsg: 'The server is not responding. Please try again.',
	noInternetTitle: 'No Internet Connection',
	noInternetMsg: 'Please check your Internet connection and try again.',
	fordnewsTitle: '@FordNews',
	fordnewsErrorTitle: 'FordNews Error',
	pageLoadErrorMsg: 'Failed to load the page. Please try again.',
	registerErrorMsg: 'User Registration failed. Please reinstall @FordNews.',
	catSubTitle: 'Category Subscription',
	catSubSuccessMsg: 'You have successfully updated your Push Notification category preferences.',
	catSubErrorMsg: 'Failed to update Push Notification category preferences. Please try again.',
	subLangTitle: 'Subscription Language',
	subLangErrorMsg: 'Failed to update Push Notification language preferences. Please try again.',
	emptyRecentArticles: 'Each article you are notified about will be displayed here.  No recent notifications have been received.',
	languageWarning: 'Please select at least one language for subscription.',
	
	// Application launcher
	initialize: function(){
		this.bindEvents();
	},
	// Bind all events that are required on startup
	bindEvents: function(){
		document.addEventListener("deviceready", fordnewsConfig.onDeviceReady, false);	   	   	
	},
	// deviceready event handler
	onDeviceReady: function(){
	    if (parseFloat(window.device.version) >= 7.0) {
            $("#header-logo").css("background-size", "auto 45%");
            $(".header-rightbtn").css("margin-top", 8);
            $(".header-leftbtn").css("margin-top", 8);
            $("#fordnews-header").css("height", 65);
            $(".content").css("margin-top", 65);
        }
		fordnewsConfig.retryCount = 0;
		// Android device back button handler
		document.addEventListener('backbutton', function (e) { fordnewsManager.goBack();}, false);		
		fordnewsConfig.disableCacheParam = '?no-cache='+new Date().getTime();// get current time to avoid iOS 6.0 caching
		if(fordnewsConfig.pushNotification == null || fordnewsConfig.pushNotification == undefined || fordnewsConfig.pushNotification == '')
			fordnewsConfig.pushNotification = window.plugins.pushNotification;
		fordnewsManager.getLanguage(); // get the user language
		// to get the selected category count
		fordnewsConfig.initCategoriesList = __localStorage.get(fordnewsConfig.categoryListPage+'_data');
		// if different lan clear all local data
		if(__localStorage.get('userLang') != fordnewsConfig.userLanguage)
			fordnewsManager.clearFordData(); // clear cached json data
		else
			fordnewsManager.clearStaticData();
		// version check
		var oldVersion = __localStorage.get('appversion');		
		if(oldVersion != null && oldVersion != undefined && oldVersion != '' && oldVersion != 'null')
			if(oldVersion != fordnewsConfig.appVersion)
				__localStorage.clear();			
		__localStorage.set('appversion', fordnewsConfig.appVersion);
		fordnewsConfig.userEnvironment = device.platform; // get device type
		// Register user to the Application Server
		fordnewsConfig.userId = __localStorage.get('userId');
		fordnewsConfig.userToken = __localStorage.get('userToken');
		fordnewsConfig.userAgreement = __localStorage.get('useragreement');
		__localStorage.set('userLang', fordnewsConfig.userLanguage);
		// Find the starting page
		if(fordnewsConfig.userAgreement == true || fordnewsConfig.userAgreement == 'true'){
			fordnewsConfig.firstVisit = __localStorage.get('firstvisit');
			// Redirect to categoryListPage, if no Categories subscribed
			if(fordnewsConfig.initCategoriesList != undefined && fordnewsConfig.initCategoriesList != null && fordnewsConfig.initCategoriesList != '' && fordnewsConfig.initCategoriesList.selectedCategoryList == ""){
				fordnewsConfig.startPage = fordnewsConfig.categoryListPage;
			}else
				fordnewsConfig.startPage = fordnewsConfig.articlesPage;
		}
		else{
			fordnewsConfig.firstVisit = true;
			__localStorage.set('firstvisit', true);
			fordnewsConfig.startPage = fordnewsConfig.termsPage;			
		}
		setTimeout(function(){navigator.splashscreen.hide();},3500);
		fordnewsManager.showSpinner();
		// Check whether the userId is available
		if(fordnewsConfig.userId == null || fordnewsConfig.userId == '' || fordnewsConfig.userId == undefined || fordnewsConfig.userId == 'null'){
			// userId and UserToken are empty
			fordnewsConfig.userId = '';				
			fordnewsConfig.userToken = '';
		}else{
			//// UserToken is empty
			fordnewsConfig.userToken = '';
		}		
		setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.startPage);},500);
		if(fordnewsConfig.userToken == '' || fordnewsConfig.userToken == null || fordnewsConfig.userToken == undefined || fordnewsConfig.userToken == 'null'){
			fordnewsConfig.retryCount++;
			setTimeout(function(){fordnewsManager.pushRegistration();},10);
		}
	},
	webLaunch: function(){
	    fordnewsConfig.disableCacheParam = '?no-cache='+new Date().getTime();
		setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.articlesPage);},500);
		fordnewsManager.hideSpinner();
	}
};
var historyManagementArray = {
	categorylist: fordnewsConfig.articlesPage,
	aboutus: fordnewsConfig.languageSelectorPage,
	license: fordnewsConfig.aboutusPage,
	languageselector: fordnewsConfig.categoryListPage
};
__localStorage.set('firsttimeuser', false);