/**
*
 * @author Ansad
* @date 8-30-2013
* @desc @Ford News framework to handle system flow
*
*/
var fordnewsManager = {	
	contexts : [
	            {name: "articles", template: "templates/artciles.html", isApiService: true, isRSSService: false, isLocalJsonData: false, isStatic: false, isHeader: true, postRender:fordnewsAdapter.initArticlesHandler, leftPane: null, rightPane: 'btn_config'},	            
	            {name: "terms", template: "templates/terms.html", isApiService: false, isRSSService: true, isLocalJsonData: false, isStatic: false, isHeader: true, postRender:fordnewsAdapter.initTermsHandler, followContext: fordnewsConfig.articlesPage, leftPane: null, rightPane: null},
	            {name: "categorylist", template: "templates/categorylist.html", isApiService: true, isRSSService: false, isLocalJsonData: false, isStatic: false, isHeader: true, postRender:fordnewsAdapter.initCategoryListHandler, followContext: fordnewsConfig.articlesPage, leftPane: 'btn_back', rightPane: 'btn_language'},
	            {name: "languageselector", template: "templates/languageselector.html", isApiService: true, isRSSService: false, isLocalJsonData: false, isStatic: false, isHeader: true, postRender:fordnewsAdapter.initLanguageSelectorHandler, leftPane: 'btn_back', rightPane: 'btn_home'},
	            {name: "aboutus", template: "templates/aboutus.html", isApiService: false, isRSSService: true, isLocalJsonData: false, isStatic: false, isHeader: true, postRender:fordnewsAdapter.initAboutUsHandler, leftPane: 'btn_back', rightPane: 'btn_home'},
	            {name: "license", template: "templates/license.html", isApiService: false, isRSSService: true, isLocalJsonData: false, isStatic: false, isHeader: true, postRender:'', leftPane: 'btn_back', rightPane: 'btn_home'}	            
	            ],	
	subscribtionExpandItems: [],
	 pushCounter:0,
	// Change the view, load from cache if exists, redirects to changePageView
	changePageView: function(pageId, serviceUrl){
		fordnewsManager.showSpinner();
		setTimeout(function(){fordnewsManager.changePage(pageId, serviceUrl);},10);
	},
	changePage: function(pageId, serviceUrl){
		this.getLanguage();
		// Clear cached data - Article details page & About us
		__localStorage.set(fordnewsConfig.articlesPage+'_data', null);
		__localStorage.set(fordnewsConfig.aboutusPage+'_data', null);
		__localStorage.set(fordnewsConfig.categoryListPage+'_data', null);
		try{
			var context = fordnewsManager.getPageData(pageId);
			// get the template
			var template = __localStorage.get(pageId+'_template');
			// Data will be already there, just embed it
	    	if(template == null || template == '' || template == undefined || template == 'undefined'){
	    		this.fetchTemplate(context.name, context.template);
	       	}
	       	if(pageId == fordnewsConfig.aboutusPage || pageId == fordnewsConfig.licensePage)
	       		var localJson = __localStorage.get(pageId+fordnewsConfig.userLanguage+'_data');
	       	else
	       		var localJson = __localStorage.get(pageId+'_data');
	       	//if(localJson == null || localJson == '' || localJson == undefined || localJson == 'undefined'){
	       		if(context.isApiService){
	       			var requestJson = '';
	       			switch(context.name){
	       				case fordnewsConfig.categoryListPage:
	       					requestJson = {"userId": fordnewsConfig.userId,"userLang": fordnewsConfig.userLanguage};
	       					serviceUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.getCategoryUrl;
	       					break;
	       				case fordnewsConfig.articlesPage:
	       					serviceUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.getRecentArticlesUrl;
	       					requestJson = {"userId": fordnewsConfig.userId};
	       					break;
	       				case fordnewsConfig.languageSelectorPage:
	       					serviceUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.getPushLanguages;
	       					requestJson = {"userId": fordnewsConfig.userId};
	       					break;
	       				default:
	       					break;
	       			}	       				
	       			setTimeout(fordnewsManager.getContextData(context, serviceUrl, requestJson), 10); // get the json data from server
	       		}else if(context.isRSSService){
	       			setTimeout(fordnewsManager.getRSSresponse(context), 10); // get the json data from RSS feed
	       		}else if(context.isStatic){
	       			fordnewsManager.loadFordPage(context);  // load the static page
	       		}
	       	/*}else{
	       		fordnewsManager.loadFordPage(context, localJson);
	       	}*/
    	}catch(e){}
	},
	// get the page data by using pageId
	getPageData: function(pageId){
		var pageData = null;
		var contextLength = fordnewsManager.contexts.length;
		for(var i=0; i<contextLength; i++){
			if(fordnewsManager.contexts[i].name == pageId){
				pageData = fordnewsManager.contexts[i];
				break;
			}
		}
		return pageData;
	},
	// get the template data
	fetchTemplate: function(pageId, templateId){
		 $.ajax({
             url: templateId,
             async:false,
             context: pageId,
             dataType:'html',
             timeout: fordnewsConfig.requestTimeout,
             success: function(data){
                 __localStorage.set(pageId+'_template', data);
             },
             error: function(data){
                 __localStorage.set(pageId+'_template', null);
             }
         });
	},
	// get the context data from server
	getContextData: function(contextData, serviceUrl, requestJson){
		//console.log(contextData.name+"Inside-->getContextData()");		
		try{
			if(fordnewsManager.isnetworkConnection()){
				$.ajax({
		              type: 'POST',
		              url: serviceUrl+fordnewsConfig.disableCacheParam,
		              async: true,
		              contentType: "application/json",
		              data: JSON.stringify(requestJson),
		              dataType: 'json',
		              timeout: fordnewsConfig.requestTimeout,
		              context: contextData,
		              success: function(responseJson){
		              	try{
		              		__localStorage.set(contextData.name+'_data', responseJson);
		              		fordnewsManager.loadFordPage(contextData, responseJson);		              		
			            }
		                catch(e){
		                	if(contextData.name == fordnewsConfig.termsPage)
		              			fordnewsConfig.exitFordNews = true;
		                	fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);
		                }
		              },
		              error: function(jqXHR, textStatus, errorThrown){
						if(textStatus == 'timeout'){
							if(contextData.name == fordnewsConfig.termsPage)
		              			fordnewsConfig.exitFordNews = true;
	              			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverTimeoutMsg);	              			
	              		}
	              		else{
	              			if(contextData.name == fordnewsConfig.termsPage)
		              			fordnewsConfig.exitFordNews = true;
	            			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);	            			
						}           	  
		              }
		          });
			}else{
				if(contextData.name == fordnewsConfig.termsPage)
		            fordnewsConfig.exitFordNews = true;
				fordnewsManager.exceptionHandler(fordnewsConfig.noInternetTitle, fordnewsConfig.noInternetMsg);				
			}
		}catch(e){
			if(contextData.name == fordnewsConfig.termsPage)
		    	fordnewsConfig.exitFordNews = true;
			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);
		}
	},
	// Load the page by integrating data to template
	loadFordPage: function(context, jsonData){
		var template = __localStorage.get(context.name+'_template');
		var contextHtml = $('.content_'+context.name);
		if(context.isStatic)// render static file
			contextHtml.html(template);
		else if(context.isRSSService){
			contextHtml.html(template);
			contextHtml.find('.page-static').html(jsonData);
		}else{ // render template with json data	
		    if(context.name!="categorylist"){
		        contextHtml.html(template);
		        contextHtml.jsonrender(jsonData);
		    }else{
		        contextHtml.html("");
		        fordnewsManager.subscribtionExpandItems = [];
		        var temp = fordnewsManager.generateCatagoryList(jsonData);
		        contextHtml.html(temp);
		        $(".toggleCheckChnage").bind('click', function(event){
		            event.stopPropagation();
	                if(($(this).find('img').css('display') == 'none') && (fordnewsConfig.firstVisit == 'true' || fordnewsConfig.firstVisit == true) && fordnewsConfig.initCategoriesList != undefined && fordnewsConfig.initCategoriesList != null && fordnewsConfig.initCategoriesList != '' && fordnewsConfig.initCategoriesList.selectedCategoryList == ""){
	                    fordnewsManager.exceptionHandler(fordnewsConfig.catSubTitle, $(__localStorage.get('popupMsg'+fordnewsConfig.userLanguage+'_data')).text());
	                    fordnewsConfig.firstVisit = false;
	                    __localStorage.set('firstvisit', false);
	                }
	                $(this).find("img").toggle();
                    if($("#"+this.parentElement.id+" img[style*='display: none']").length == 0){
                        $(this.parentElement.previousElementSibling).find('input').prop("checked","true");
                    }else{
                        $(this.parentElement.previousElementSibling).find('input').removeAttr("checked");
                    }
		        });  
		        //UI fix for Android 2.3
		        if(device.version.indexOf("2.3")!= -1){
		            $(".content_categorylist").css("font-size", "2.2em");
		            $(".btn-subscribe").css("width", "140px");
		        }
		    }//UI fix for Android 2.3
		    if(context.name == "languageselector"){
                if(device.version.indexOf("2.3")!= -1){
                    $(".lang-switch").css("bottom", "10px !important");
                }
		    }
		}		
		$('.content').hide();
		contextHtml.show();		
		//Set the current Context and Previous Context
		fordnewsConfig.previousContext = fordnewsConfig.currentContext;
		fordnewsConfig.currentContext = context.name;		
		// Add header
		if(context.isHeader)			
			fordnewsManager.showHeader(context);
		else
			fordnewsManager.removeHeader();
		// call event handling method
		if(typeof context.postRender == 'function')
			context.postRender();
		setTimeout(function(){window.scrollTo(0, 1);},10);
		fordnewsManager.hideSpinner();
		if(context.name == "categorylist"){
	        $(".Drildown").getReady({
                barColor:"white"
            });
            $.each(fordnewsManager.subscribtionExpandItems, function(i, item){
                $("#DrildownMenuItem"+item).click();
            });
		}
	},	
	// Display the loading spinner
	showSpinner: function(){
		$('.ui-loader-background').show();
	},
	// Hide the loading spinner
	hideSpinner: function(){
		$('.ui-loader-background').hide();
	},
	// Back button functionality
    goBack: function(){
    	var prevState = historyManagementArray[fordnewsConfig.currentContext];    	
		if(prevState != undefined && prevState != null && prevState != '' && prevState != 'undefined'){
			if(fordnewsConfig.previousContext == fordnewsConfig.termsPage && fordnewsConfig.currentContext != fordnewsConfig.categoryListPage)
				fordnewsManager.changePageView(fordnewsConfig.termsPage);
			else
				fordnewsManager.changePageView(prevState);	
		}else			
			fordnewsManager.exitFordNews();				
    },
	// show header
	showHeader: function(context){
		fordnewsManager.removeHeader();
		$('#fordnews-header').show();
		if(context.leftPane)
			$('#'+context.leftPane).show();
		if(context.rightPane && (fordnewsConfig.userAgreement == true || fordnewsConfig.userAgreement == 'true'))
			$('#'+context.rightPane).show();
	},
	// Hide header
	removeHeader: function(){
		$('#fordnews-header').hide();
		$('#btn_back').hide();
		$('#btn_home').hide();
		$('#btn_config').hide();
		$('#btn_language').hide();
	},
	// get RSS content and Parse it
	getRSSresponse: function(context){
		try{
			if(fordnewsManager.isnetworkConnection()){
				$.ajax({
					type: "POST",
					url: fordnewsConfig.rssfeedUrl,
					dataType: "xml",
					async: true,
					timeout: fordnewsConfig.requestTimeout,
					context: context,
					success: function(xml){
						try{
							var termsAndConditions;
							var $xml = $(xml);
							$xml.find("item").each(function(){
								var $this = $(this),
								item = {
										title: $this.find("title").text(),
										link: $this.find("link").text(),
										description: $this.find("description").text()
										}
								switch(fordnewsConfig.userLanguage){
									case 'de':
										if(item.title == 'About Us German')
											__localStorage.set(fordnewsConfig.aboutusPage+fordnewsConfig.userLanguage+'_data', item.description);
										else if(item.title == 'Other Legal Info German')
											__localStorage.set(fordnewsConfig.licensePage+fordnewsConfig.userLanguage+'_data', item.description);
										else if(item.title == 'Popup Msg German')
											__localStorage.set('popupMsg'+fordnewsConfig.userLanguage+'_data', item.description);
										else if(item.title == 'Terms and Conditions German')
											termsAndConditions = item.description;
										break;
									case 'en':
										if(item.title == 'About Us')
											__localStorage.set(fordnewsConfig.aboutusPage+fordnewsConfig.userLanguage+'_data', item.description);
										else if(item.title == 'Other Legal Info')
											__localStorage.set(fordnewsConfig.licensePage+fordnewsConfig.userLanguage+'_data', item.description);
										else if(item.title == 'Popup Msg')
											__localStorage.set('popupMsg'+fordnewsConfig.userLanguage+'_data', item.description);
										else if(item.title == 'Terms and Conditions')
											termsAndConditions = item.description;
										break;
									default:
										break;
								}
							});
							// Based on the context, display the description
							if(context.name == fordnewsConfig.termsPage)
								fordnewsManager.loadFordPage(context, termsAndConditions);
							else						
								fordnewsManager.loadFordPage(context, __localStorage.get(context.name+fordnewsConfig.userLanguage+'_data'));							
						}catch(e){
							if(context.name == fordnewsConfig.termsPage)
		            			fordnewsConfig.exitFordNews = true;
							fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);							
						}
					},
					error:function(jqXHR, textStatus, errorThrown){
						if(textStatus == 'timeout'){
							if(context.name == fordnewsConfig.termsPage)
		            			fordnewsConfig.exitFordNews = true;
	              			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverTimeoutMsg);	              			
		            	}
	              		else{
	              			if(context.name == fordnewsConfig.termsPage)
		            			fordnewsConfig.exitFordNews = true;
	            			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);	            			
						}           	  
		          	}
				});
			}else{
				if(context.name == fordnewsConfig.termsPage)
					fordnewsConfig.exitFordNews = true;
				fordnewsManager.exceptionHandler(fordnewsConfig.noInternetTitle, fordnewsConfig.noInternetMsg);				
			}
		}catch(e){
			if(context.name == fordnewsConfig.termsPage)
				fordnewsConfig.exitFordNews = true;
			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);			
		}
	},
	// Get the user's device language and set it as a global parameter
	getLanguage: function(){
		navigator.globalization.getPreferredLanguage(fordnewsManager.successLangCallback, fordnewsManager.errorLangCallback);
	},
	// success call back for getPreferredLanguage API
	successLangCallback: function(language){
		var languageVal = language.value.toLowerCase();
		if(languageVal.indexOf('de')!=-1)
			fordnewsConfig.userLanguage = 'de';
		else
			fordnewsConfig.userLanguage = 'en';
	},
	// Error call back for getPreferredLanguage API
	errorLangCallback: function(){
		// Error getting language
	},
	// Common Error Handling
    exceptionHandler: function(title, message){
     	//alert(message);
       	//fordnewsManager.hideSpinner();
		navigator.notification.alert(message, fordnewsManager.errorCallback, title, fordnewsConfig.okButtonText);
    },
     // Error Call back method
    errorCallback: function(){
    	// load the home page
    	fordnewsManager.hideSpinner();
    	if(fordnewsConfig.exitFordNews)
    		fordnewsManager.exitFordNews();
    },
	// check network connection status
    isnetworkConnection: function(){
    	var networkState = navigator.network.connection.type;    	
    	if(networkState == Connection.NONE)
    		return false;
    	else
    		return true;
    },
	// Register the device to APNS/GCM
	pushRegistration: function(){
		// make the url
		if(fordnewsManager.isnetworkConnection()){
			if(device.platform == 'android' || device.platform == 'Android'){
		    	fordnewsConfig.pushNotification.register(fordnewsManager.pushRegisterSuccessHandler, fordnewsManager.pushRegisterErrorHandler,{"senderID": fordnewsConfig.gcmSenderId,"ecb":"fordnewsManager.onNotificationGCM"});
			}else{
			    fordnewsConfig.pushNotification.register(fordnewsManager.apnsTokenHandler, fordnewsManager.pushRegisterErrorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"fordnewsManager.onNotificationAPN"});
			}
		}
	},	
	// result contains any message sent from the plugin call
	pushRegisterSuccessHandler: function(result){
	     //console.log("Push Registration success--> "+result);
	},
	// result contains any error description text returned from the plugin call
	pushRegisterErrorHandler: function(error){
	    fordnewsManager.showRegistrationError();		
	},
	apnsTokenHandler: function(result){
	    // Ford push server needs to know the regID before it can push to this device
        // send the regID to Application Server for later use.||Dummy
        if(result == undefined){
            fordnewsManager.pushCounter= fordnewsManager.pushCounter + 1;
        }
        if(fordnewsManager.pushCounter == 3){
            if(_localStorage.get('userToken')){
                result = _localStorage.get('userToken');
            }else{
                result = fordnewsManager.generateRandamKey();
            }
            
        }	   
    	fordnewsConfig.userToken = result;
        __localStorage.set('userToken', fordnewsConfig.userToken);
        setTimeout(function(){fordnewsManager.userRegistration(fordnewsConfig.startPage);},10);
    },
    // Notification receiver on iOS
    onNotificationAPN: function(event){
        var payload = fordnewsManager.generatePayloadAPNS(event.acme);
        var url = fordnewsManager.generateArticalURL(payload);
        if(event.foreground == '1'){
            if(event.alert){
                fordnewsManager.notificationPopup(event.alert, url, payload.social);
            }
        }else{          
            fordnewsManager.loadArticleDetailsPage(url, payload.social, payload.message);
        }
        if(event.sound){
    	    var snd = new Media(event.sound);
        	snd.play();
    	}if(event.badge){
    		console.log("badge--->"+event.badge);
    	}
	},
	// Badge success handler
	successBadgeHandler: function(e){
		console.log("successBadgeHandler-->"+e);
	},
	// Badge error handler
	errorBadgeHandler: function(e){
		console.log("errorBadgeHandler-->"+e);
	},
	// Notification receiver on  Android
    onNotificationGCM: function(e){
        //console.log("onNotificationGCM-->Event-->"+JSON.stringify(e));
        //console.log("onNotificationGCM-->Payload-->"+JSON.stringify(e.payload));
        switch(e.event){
            case 'registered':
            if(e.regid.length > 0){
                //console.log("regID = " + e.regid);
                // Ford push server needs to know the regID before it can push to this device
                // send the regID to Application Server for later use.
                fordnewsConfig.userToken = e.regid;
                __localStorage.set('userToken', fordnewsConfig.userToken);
                //fordnewsManager.showSpinner();
        		setTimeout(function(){fordnewsManager.userRegistration(fordnewsConfig.startPage);},10);                              
            }
            break;
            case 'message':
                // if this flag is set, this notification happened while we were in the foreground.
                // you might want to play a sound to get the user's attention, throw up a dialog, etc.
                var url= fordnewsManager.generateArticalURL(e.payload);
                var socialShare = e.payload.social == "Y" ?  true : false;
                if(e.foreground){
                	//console.log("--Foreground NOTIFICATION--");
                    // if the notification contains a soundname, play it.
                    var my_media = new Media("/android_asset/www/"+e.soundname);
                    my_media.play();
                    fordnewsManager.notificationPopup(e.payload.message, url, socialShare);
                }else{   // otherwise we were launched because the user touched a notification in the notification tray.
                    if(e.coldstart)
                    	console.log("--COLDSTART NOTIFICATION--");
                    else
                    	console.log("--BACKGROUND NOTIFICATION--");
                    
                    fordnewsManager.loadArticleDetailsPage(url, socialShare, e.payload.message);
                }                
                
            break;
            case 'error':
                console.log("onNotificationGCM--Error-->"+e.msg);
                fordnewsManager.showRegistrationError();
            break;
            default:
                console.log("EVENT -> Unknown, an event was received and we do not know what it is");
                fordnewsManager.showRegistrationError();
            break;
        }
	},
	// User registration to Application server
	userRegistration: function(){
		if(fordnewsConfig.userId != null && fordnewsConfig.userId != '' && fordnewsConfig.userId != undefined && fordnewsConfig.userId != 'null'){			
			var updateUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.updateUserDetails;
    		var requestJson = {"userId": fordnewsConfig.userId, "deviceToken": fordnewsConfig.userToken,"deviceType": fordnewsConfig.userEnvironment, "userLang": fordnewsConfig.userLanguage};			
		}else{
			var updateUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.userRegisterUrl;
			var requestJson = {"deviceToken": fordnewsConfig.userToken,"userLang": fordnewsConfig.userLanguage, "deviceType": fordnewsConfig.userEnvironment};
		}
		fordnewsManager.registerUser(updateUrl, requestJson);
	},
	// Update context data and load another page
	updateContext: function(currentContext, updateUrl, requestJson, controller){
		try{
			var contextData = fordnewsManager.getPageData(currentContext);
			//console.log("inside --> updateContext-->"+contextData.name);
			if(fordnewsManager.isnetworkConnection()){
				$.ajax({
		              type: 'POST',
		              url: updateUrl+fordnewsConfig.disableCacheParam,
		              async: true,
		              contentType: "application/json",
		              data: JSON.stringify(requestJson),
		              dataType: 'json',
		              timeout: fordnewsConfig.requestTimeout,
		              context: contextData,
		              success: function(responseJson){
		              	try{
		              			//console.log(contextData.name+"res-->"+JSON.stringify(responseJson));
		              			var status = responseJson.status; 
		              			//alert(JSON.stringify(responseJson));
		              			fordnewsManager.hideSpinner();		              			
			            	 	if(status == 'true' || status == true){									
									if(contextData.name == fordnewsConfig.categoryListPage){
										fordnewsManager.exceptionHandler(fordnewsConfig.catSubTitle, fordnewsConfig.catSubSuccessMsg);
										fordnewsManager.goBack();
										__localStorage.set(fordnewsConfig.categoryListPage+'_data', null);
										__localStorage.set(fordnewsConfig.articlesPage+'_data', null);
									}else if(contextData.name == fordnewsConfig.languageSelectorPage){
										__localStorage.set(fordnewsConfig.languageSelectorPage+'_data', null);										
				            			controller.toggleClass('on');
									}
				            	}else if(status == 'false' || status == false){				            			
			            			if(contextData.name == fordnewsConfig.termsPage){
			            				fordnewsConfig.exitFordNews = true;
			            			}
			            			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);
				            	}				            	
				            	//var useragreement = __localStorage.get('useragreement');
				            	/*if(contextData.name == fordnewsConfig.termsPage && (useragreement == true || useragreement == 'true')){
				            		setTimeout(function(){fordnewsManager.changePageView(contextData.followContext);},10);
				            		__localStorage.set('firsttimeuser', true);
				            	}
				            	else*/				            		
			            	}
		                catch(e){
		                	//console.log(contextData.name+"-->Exception-->"+e);
		                	if(contextData.name == fordnewsConfig.termsPage){
				            	fordnewsConfig.exitFordNews = true;
				           	}
		                	fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);                	
		                }
		              },
		              error: function(jqXHR, textStatus, errorThrown){
		              	if(contextData.name == fordnewsConfig.termsPage){
				        	fordnewsConfig.exitFordNews = true;
				        }
		              	//console.log(contextData.name+"-->Error-->"+JSON.stringify(jqXHR)+"textStatus-->"+textStatus+"errorThrown-->"+errorThrown);
						if(textStatus == 'timeout')
	              			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverTimeoutMsg);
	              		else
	            			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);           	  
		              }
		          });
			}else{
				if(contextData.name == fordnewsConfig.termsPage){
					fordnewsConfig.exitFordNews = true;
				}
				fordnewsManager.exceptionHandler(fordnewsConfig.noInternetTitle, fordnewsConfig.noInternetMsg);
			}
		}catch(e){
			if(contextData.name == fordnewsConfig.termsPage){
				fordnewsConfig.exitFordNews = true;
			}
			//console.log(contextData.name+"-->Exception-->"+e);
			fordnewsManager.exceptionHandler(fordnewsConfig.serverPblmTitle, fordnewsConfig.serverPblmMsg);
		}
	},	
    // get user token from Application server using userId
    getUserDetails: function(){
    	var updateUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.getUserDetails;
    	var requestJson = {"userId": fordnewsConfig.userId};
    	fordnewsManager.getFordData(fordnewsConfig.termsPage, updateUrl, requestJson);
   },
   // get the category data
   getCategoryData: function(){
   		var updateUrl = fordnewsConfig.webserviceUrl+fordnewsConfig.getCategoryUrl;
   		var requestJson = {"userId": fordnewsConfig.userId,"userLang": fordnewsConfig.userLanguage};		
		fordnewsManager.getFordData(fordnewsConfig.categoryListPage, updateUrl, requestJson);
   },
   // API service to get App related details
   getFordData: function(context, updateUrl, requestJson){
   	//console.log("inside getFordData"+context);
   		try{
			if(fordnewsManager.isnetworkConnection()){
				$.ajax({
		              type: 'POST',
		              url: updateUrl+fordnewsConfig.disableCacheParam,
		              async: true,
		              contentType: "application/json",
		              data: JSON.stringify(requestJson),
		              dataType: 'json',
		              timeout: fordnewsConfig.requestTimeout,
		              context: context,
		              success: function(responseJson){
                       
                       
                       
		              	try{
		              		if(context == fordnewsConfig.termsPage)
				            	fordnewsConfig.userToken = responseJson.deviceToken;
				            else if(context == fordnewsConfig.categoryListPage)
				            	__localStorage.set(fordnewsConfig.categoryListPage+"_data", responseJson);
				            fordnewsManager.hideSpinner();
				            if(!fordnewsConfig.userAgreement && context == fordnewsConfig.categoryListPage && fordnewsConfig.currentContext == fordnewsConfig.termsPage && fordnewsConfig.retryCount > 1)
				            	$('#agree_btn').click();
			            	}
		                catch(e){
		                	fordnewsManager.hideSpinner();
		                }
		              },
		              error: function(jqXHR, textStatus, errorThrown){
                        fordnewsManager.hideSpinner();
		              }
		          });
			}
		}catch(e){
			fordnewsManager.hideSpinner();
		}
   	
   },
   // update user details by using userid
    registerUser: function(updateUrl, requestJson){    	
    	try{
			if(fordnewsManager.isnetworkConnection()){
				$.ajax({
		              type: 'POST',
		              url: updateUrl+fordnewsConfig.disableCacheParam,
		              async: true,
		              contentType: "application/json",
		              data: JSON.stringify(requestJson),
		              dataType: 'json',
		              timeout: fordnewsConfig.requestTimeout,		              
		              success: function(responseJson){
		              	try{
		              			var status = responseJson.status;
		              			if(status == 'true' || status == true){
		              				if(responseJson.userId && responseJson.userId != null && responseJson.userId != '' && responseJson.userId != undefined){
										fordnewsConfig.userId = responseJson.userId;
										__localStorage.set('userId', fordnewsConfig.userId);
									}
									if(fordnewsConfig.userId != null || fordnewsConfig.userId != undefined || fordnewsConfig.userId != '' || fordnewsConfig.userId != 'null'){
										fordnewsConfig.isRegister =  true;
										setTimeout(function(){fordnewsManager.getCategoryData();},10);
									}
		              			}else
		              				fordnewsManager.showRegistrationError();
			            	}
		                catch(e){
		                	fordnewsManager.showRegistrationError();
		                }
		              },
		              error: function(jqXHR, textStatus, errorThrown){
		              	fordnewsManager.showRegistrationError();		              	
		              }
		          });
			}			
		}catch(e){
			//console.log("registerUser-->Exception-->"+e);	 
			fordnewsManager.showRegistrationError();       
		}
   },
   // Show registration error if retry count > 1
   showRegistrationError: function(){
   		if(fordnewsConfig.retryCount > 2)
   			fordnewsManager.exceptionHandler(fordnewsConfig.fordnewsErrorTitle, fordnewsConfig.registerErrorMsg);
   		else{
   			fordnewsConfig.retryCount++;
			setTimeout(function(){fordnewsManager.pushRegistration();},10);
   		}   		
   },
   // load Article details page by using url
   loadArticleDetailsPage: function(articleUrl, socialFlag, title){
   		if(fordnewsManager.isnetworkConnection()){
   			__localStorage.set(fordnewsConfig.articlesPage+'_data', null);
   			cordova.exec(fordnewsManager.successArticleDetails, fordnewsManager.errorArticleDetails, "ArticleView","launchArticleView", [articleUrl, socialFlag, title]);   			
   		}else{
   			fordnewsManager.exceptionHandler(fordnewsConfig.noInternetTitle, fordnewsConfig.noInternetMsg);
   		}
   },
   // Success handler from article details page
   successArticleDetails: function(result){
   		//if(result == "success")alert("success-->"+result);
   		setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.articlesPage);},10);
   },
   // Error handler from article details page
   errorArticleDetails: function(e){
   	//alert("errorArticleDetails-->"+e)	
   	setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.articlesPage);},10);
   },
   // Application exit
   exitFordNews: function(){
   		if(device.platform == 'android' || device.platform == 'Android' ){ 		
   			setTimeout(function(){navigator.app.exitApp();},10);
   		}
   },
   // unregister success handler
   unregistersuccessHandler: function(){
		 // TO DO...  	
   },
   // unregister error handler
   unregistererrorHandler: function(){
   		// TO DO...
   },
   // Clear local storage data to reflect new changes
   clearFordData: function(){
   		__localStorage.set(fordnewsConfig.articlesPage+'_data', null);
   		__localStorage.set(fordnewsConfig.categoryListPage+'_data', null);
   		__localStorage.set(fordnewsConfig.languageSelectorPage+'_data', null);
   		__localStorage.set('userToken', null);
   },
   // Notification Popup handler handler
	notificationPopup: function(message, articleURL, socialShare){
		navigator.notification.confirm(message, function(buttonIndex){
			fordnewsManager.confirmPopup(buttonIndex, articleURL, socialShare, message);
		}, fordnewsConfig.fordnewsTitle, [fordnewsConfig.cancelButtonText,fordnewsConfig.continueButtonText]);
	},
	// confirm popup
	confirmPopup: function(buttonIndex, articleURL, socialShare, message){
		if(buttonIndex == 1){
			__localStorage.set(fordnewsConfig.articlesPage+'_data', null);
			if(fordnewsConfig.currentContext == fordnewsConfig.articlesPage)
				setTimeout(function(){fordnewsManager.changePageView(fordnewsConfig.articlesPage);},10); 
		}else if(buttonIndex == 2){
			fordnewsManager.loadArticleDetailsPage(articleURL, socialShare, message);
		}
	},
	// CLear static contents and articles page
	clearStaticData: function(){
		__localStorage.set(fordnewsConfig.articlesPage+'_data', null);
		__localStorage.set(fordnewsConfig.aboutusPage+fordnewsConfig.userLanguage+'_data', null);
	},
	//Generate artical URL for GCM
	generateArticalURL: function(payload){
        if (payload.rss == fordnewsConfig.rssType.Regional) {
            return fordnewsConfig.hostName + fordnewsConfig.urlRegionalPart
                    + payload.title + fordnewsConfig.urlLastPart
                    + payload.category;
        } else if (payload.rss == fordnewsConfig.rssType.Plant) {
            return fordnewsConfig.hostName + fordnewsConfig.urlPlantPart
                    + payload.plant + fordnewsConfig.urlPlantSecondPart
                    + payload.title + fordnewsConfig.urlLastPart
                    + payload.category;
        } else if (payload.rss == fordnewsConfig.rssType.German) {
            return fordnewsConfig.hostName + fordnewsConfig.urlGermanPart
                    + payload.title + fordnewsConfig.urlLastPart
                    + payload.category;
        }
	},
	//Generate payload from push string for APNS
	generatePayloadAPNS: function(query) {
        var data = query.split("$$")
        return {
            "category" : data[0],
            "title" : data[3],
            "rss" : data[1],
            "plant" : data[2],
            "social" : data[4]
        }
    },
    //Creating catagorylist in catagory page
    generateCatagoryList:  function(categoryObject){
        var content = "";
        var counter = 0;
        content = content + "<div class='subscription-head'><span>Select Subscription Category</span><img src='skin/css/images/btn-subscribe.png'";
        content = content + " class='btn-subscribe' id='btn-subscribe'/></div><div style=\"padding: 0 0 30px 0;\">";
        $.each(categoryObject.categoryGroupList, function(groupCount, groupObject){
            if(groupObject.categoryList.length != 0){
                content = content + "<div class='Drildown'><span"
                if(groupObject.expand == "Y"){
                    fordnewsManager.subscribtionExpandItems.push(counter);
                }else{
                    content = content + " class='noToggleGroup'";
                }
               counter = counter + 1;
                content = content + ">" + groupObject.groupName + "</span></div><div class='inner'>";
                $.each(groupObject.categoryList, function(categroyCount, categoryObject){
                    content = content + "<div class='toggleCheckChnage'><span>";
                    content = content + categoryObject.categoryName;
                    content = content + "</span><img id='"+categoryObject.categoryId+"' src='skin/css/images/tick.png'";
                    var checked = categoryObject.selected ? "" : "style=\"display: none;\",";
                    content = content + checked +"/></div>";
                });
                content = content + "</div><div class=\"bottom-bar\"></div>";
            }
        });
        return content+ "</div>";
    },
    //generating random key for creating push id if user selec don't allow push for app.
    generateRandamKey: function(){
        var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
        var string_length = 9;
        var randomstring = '';
        for (var i=0; i<string_length; i++) {
            var rnum = Math.floor(Math.random() * chars.length);
            randomstring += chars.substring(rnum,rnum+1);
        }
        return randomstring + "||NOPUSH";
    },
    //to format date in calagory list page.
    convertStringToDate: function(input) {
        var dateStr = input.substring(0, 10);
        var dateParts = dateStr.split('-');
        var timeStr = input.substring(11, 19);
        var timeParts = timeStr.split(':');
        var result = new Date(Date.UTC(dateParts[0], dateParts[1]-1,
            dateParts[2], timeParts[0], timeParts[1], timeParts[2]));
        return result;
      }
};
