/**
*
 * @author Ansad
* @date 8-30-2013
* @desc JSON rendering engine and parse with template
*
*/
(function($){
  var fordtemplate = {};
  
  //fill html tag with json data
  fordtemplate.jsonrender = function(rootHtml,jsondata,map){
    var newElement;
    if(jsondata instanceof Array){
      for (var id in jsondata){
        newElement = rootHtml.clone();
        if (jsondata[id]['id']) {
          var obj_id = jsondata[id]['id'];
          delete jsondata[id]['id'];
          newElement.attr('id',obj_id)
          newElement.selector=rootHtml.selector+'#'+obj_id;
        }
        rootHtml.before(newElement);
        fordtemplate.jsonrender(newElement,jsondata[id],map);
      }
      rootHtml.remove();
    }else if(jsondata instanceof String || typeof(jsondata) === 'string'){
      if ($(rootHtml).is('img') && jsondata != "" && jsondata != undefined && jsondata != null && jsondata != 'null' && jsondata != 'NULL'){
			$(rootHtml).attr('src', jsondata);
	  }else 
	  	rootHtml.html(jsondata);
    }else if(jsondata instanceof Number || typeof(jsondata) === 'number'){
      rootHtml.html(''+jsondata);
    }else if(jsondata instanceof Boolean || typeof(jsondata) === 'boolean'){
    	if($(rootHtml).hasClass('selected') && jsondata)
      		$(rootHtml).parent('.categoryList').addClass('checked');
    }else{
      for(var key in jsondata){
        if (!jsondata.hasOwnProperty(key)) break;
        var val = jsondata[key];
        if(key == "timeStamp"){
            var dateString = jsondata[key];
            var date;
            if(device.platform == "Android"){
                date = fordnewsManager.convertStringToDate(dateString);
            }else{
                date = new Date(dateString.replace(' ', 'T'));
            }
            var hour = date.getUTCHours() > 12 ? date.getUTCHours() - 12 : date.getUTCHours();
            hour = hour < 9 ? "0" + hour : hour;
            var minute = date.getUTCMinutes() < 9 ? "0" + date.getUTCMinutes() : date.getUTCMinutes(); 
            var type = date.getUTCHours() > 12 ? "PM" : "AM";
            var day = date.getUTCDate() < 10 ? "0" + date.getUTCDate() : date.getUTCDate();
            val = fordnewsConfig.monthList[date.getMonth()] + " " + day + ", " + hour + ":" + minute + " " + type + " ET";
        }
        if (map && (map[key] || map[key]==="")){
          key = map[key];
          if (key instanceof Array){
            map = key[1];
            key = key[0];
          }
        }
        newElement = ($.trim(key)==='') ? rootHtml : rootHtml.find('.'+key);
        fordtemplate.jsonrender(newElement, val, map);
      }
    }
  };

  $.fn.jsonrender = function(jsondata,templateOptions){
	  templateOptions = templateOptions || {};
    var target = this;    
    fordtemplate.jsonrender(target,jsondata,templateOptions.map);
  }
})(jQuery)
